' Modulsammlung fr Grafik-Import und Export von QuickBASIC-
' GET/PUT-Grafikfeldern ins Windows Bitmap (*.BMP)-Format und
' umgekehrt sowie Laden der Farbpalette

' (c) 1999 by Andreas Meile, CH-8242 Hofen SH
' e-Mail: andreas@hofen.ch  WWW:http://www.hofen.ch/~andreas/

' Implementation
' $INCLUDE: 'bmp_lib.bi'
' $INCLUDE: 'qb.bi'

SUB ErzeugeTextGrafik (f#(), ind%, xAb%, yAb%, xGr%, yGr%, bpp%, zh%)
	h$ = MKI$(8 * xGr%) + MKI$(zh% * yGr%)
	' Basisadresse ermitteln
	DIM dosIntEin AS RegTypeX, dosIntAus AS RegTypeX
	dosIntEin.ax = &H1130
	SELECT CASE zh%
	CASE 8
		dosIntEin.bx = &H300
	CASE 14
		dosIntEin.bx = &H200   ' bei der ATI xpert@Work nicht mglich!
	CASE 16
		dosIntEin.bx = &H600
	CASE ELSE
		PRINT "Nicht vorhandenen Zeichengrsse"
		ERROR 5
	END SELECT
	CALL INTERRUPTX(&H10, dosIntEin, dosIntAus)
	DEF SEG = dosIntAus.es
	t$ = SPACE$(bpp% * xGr%)
	FOR y% = yAb% + 1 TO yAb% + yGr%
		FOR h% = 0 TO zh% - 1
			bAdr% = dosIntAus.bp + h%
			FOR x% = 1 TO xGr%
				z% = SCREEN(y%, x% + xAb%, 0)
				pat% = PEEK(bAdr% + zh% * z%)
				SELECT CASE bpp%
				CASE 1
					MID$(t$, x%) = CHR$(pat%)  ' Monochrom
				CASE 4
					f% = SCREEN(y%, x% + xAb%, 1)
					FOR i% = x% TO x% + 3 * xGr% STEP xGr%
						SELECT CASE f% AND &H11
						CASE &H0
							MID$(t$, i%) = CHR$(&H0)
						CASE &H1
							MID$(t$, i%) = CHR$(pat%)
						CASE &H10
							MID$(t$, i%) = CHR$(pat% XOR &HFF)
						CASE &H11
							MID$(t$, i%) = CHR$(&HFF)
						END SELECT
						f% = f% \ 2
					NEXT i%
				CASE ELSE
					PRINT "Nur 1 (monochrom) und 4 (farbig) fr bpp% zulssig"
					ERROR 5
				END SELECT
			NEXT x%
			h$ = h$ + t$
			' Byte-Daten in Array abfllen
			WHILE LEN(h$) > 8
				f#(ind%) = CVD(LEFT$(h$, 8))
				h$ = MID$(h$, 9)
				ind% = ind% + 1
			WEND
		NEXT h%
	NEXT y%
	DEF SEG
	' Rest noch abfllen
	f#(ind%) = CVD(h$ + SPACE$(8 - LEN(h$)))
	ind% = ind% + 1
END SUB

SUB HoleBildInfo (dn$, xb&, yb&, bpp%, gr%)
	OPEN dn$ + ".BMP" FOR INPUT AS 1
	CLOSE 1
	OPEN dn$ + ".BMP" FOR BINARY AS 1
	k$ = INPUT$(2, 1)
	IF k$ <> "BM" THEN
		PRINT "Kein gltiges Windows Bitmap Bild!"
		ERROR 5
	END IF
	SEEK 1, 19&
	xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
	yb& = CVL(INPUT$(4, 1))
	anzBpl% = CVI(INPUT$(2, 1))
	IF anzBpl% <> 1 THEN
		PRINT "Bildformat einer knftigen Windowsversion"
		ERROR 5
	END IF
	bpp% = CVI(INPUT$(2, 1))
	CLOSE 1
	IF bpp% = 4 THEN
		ze& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
	ELSE
		ze& = (xb& * CLNG(bpp%) + 7&) \ 8&
	END IF
	gr% = CINT((ze& * yb& + 11&) \ 8&)
END SUB

SUB LadeBild (dn$, f#(), ind%)
	OPEN dn$ + ".BMP" FOR INPUT AS 1
	CLOSE 1
	OPEN dn$ + ".BMP" FOR BINARY AS 1
	k$ = INPUT$(2, 1)
	IF k$ <> "BM" THEN
		PRINT "Kein gltiges Windows Bitmap Bild!"
		ERROR 5
	END IF
	SEEK 1, 11&
	basOf& = CVL(INPUT$(4, 1)) + 1&  ' ab hier beginnen die Nutzdaten
	SEEK 1, 19&
	xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
	yb& = CVL(INPUT$(4, 1))
	anzBpl% = CVI(INPUT$(2, 1))
	IF anzBpl% <> 1 THEN
		PRINT "Bildformat einer knftigen Windowsversion"
		ERROR 5
	END IF
	bpp% = CVI(INPUT$(2, 1))
	komp& = CVL(INPUT$(4, 1))
	IF komp& <> 0& THEN
		PRINT "Komprimierung nicht untersttzt"
		ERROR 5
	END IF
	' Start der Verarbeitung
	br& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
	IF bpp% = 8 THEN
		Pu$ = MKI$(8 * CINT(xb&))
	ELSE
		Pu$ = MKI$(CINT(xb&))
	END IF
	Pu$ = Pu$ + MKI$(CINT(yb&))
	SELECT CASE bpp%
	CASE 1, 8
		IF bpp% = 1 THEN
			b% = CINT((xb& + 7&) \ 8&)
		ELSE
			b% = CINT(xb&)
		END IF
		FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
			SEEK 1, y&
			FOR x% = 1 TO b%
				Pu$ = Pu$ + INPUT$(1, 1)
				IF LEN(Pu$) = 8 THEN
					f#(ind%) = CVD(Pu$)
					ind% = ind% + 1
					Pu$ = ""
				END IF
			NEXT x%
		NEXT y&
	CASE 4
		DIM h%(3)
		FOR i% = 0 TO 3
			h%(i%) = 0
		NEXT i%
		b% = CINT(br&) \ 4
		pu1$ = SPACE$(4 * b%)
		FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
			SEEK 1, y&
			FOR x1% = 1 TO b%
				FOR x2% = 1 TO 4
					z% = ASC(INPUT$(1, 1))
					FOR x3% = 0 TO 3
						h%(x3%) = 4 * h%(x3%) + (z% AND 1) + (z% AND 16) \ 8
						z% = z% \ 2
					NEXT x3%
				NEXT x2%
				FOR i% = 0 TO 3
					MID$(pu1$, x1% + b% * i%) = CHR$(h%(i%))
					h%(i%) = 0
				NEXT i%
			NEXT x1%
			FOR i% = 1 TO LEN(pu1$) STEP 4
				Pu$ = Pu$ + MID$(pu1$, i%, 4)
				IF LEN(Pu$) = 8 THEN
					f#(ind%) = CVD(Pu$)
					ind% = ind% + 1
					Pu$ = ""
				END IF
			NEXT i%
		NEXT y&
	CASE 24
		PRINT "Echtfarb (True Color) nicht mglich"
		ERROR 5
	CASE ELSE
		PRINT "Unbekannte Bildtiefe"
		ERROR 5
	END SELECT
	' Rest noch fllen
	IF Pu$ <> "" THEN
		f#(ind%) = CVD(Pu$ + SPACE$(8 - LEN(Pu$)))
		ind% = ind% + 1
	END IF
	CLOSE 1
END SUB

SUB LadePalette (dn$, p&(), ind%, mo%)
	OPEN dn$ + ".BMP" FOR INPUT AS 1
	CLOSE 1
	OPEN dn$ + ".BMP" FOR BINARY AS 1
	k$ = INPUT$(2, 1)
	IF k$ <> "BM" THEN
		PRINT "Kein gltiges Windows Bitmap Bild!"
		ERROR 5
	END IF
	SEEK 1, 15&
	palOf& = CVL(INPUT$(4, 1)) + 15&   ' ab hier beginnen die Farbeintrge
	SEEK 1, 27&
	anzBpl% = CVI(INPUT$(2, 1))
	IF anzBpl% <> 1 THEN
		PRINT "Bildformat einer knftigen Windowsversion"
		ERROR 5
	END IF
	bpp% = CVI(INPUT$(2, 1))
	IF bpp% > 12 THEN
		PRINT "Echtfarb verwendet keine Farbpalette"
		ERROR 5
	END IF
	' Start der Verarbeitung
	aF% = 1
	FOR i% = 1 TO bpp%
		aF% = aF% * 2
	NEXT i%
	IF mo% = PalVlf% THEN
		' verlustfreier Spezialmodus, der keinem SCREEN gehrt
		' liest gesamter RGBQUAD ein
		SEEK 1, palOf&
		FOR i% = 1 TO aF&
			p&(ind%) = CVL(INPUT$(4, 1))
			ind% = ind% + 1
		NEXT i%
	ELSE
		FOR i% = 1 TO aF%
			SEEK 1, palOf&
			b% = ASC(INPUT$(1, 1))
			g% = ASC(INPUT$(1, 1))
			r% = ASC(INPUT$(1, 1))
			SELECT CASE mo%
			CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
				Cga% = (r% AND 128) \ 32 + (g% AND 128) \ 64 + (b% AND 128) \ 128
				' Selektion, ob hellerer oder dnklerer Farbton darstellen
				h% = (r% AND 127) + (g% AND 127) + (b% AND 127) - 192
				p&(ind%) = CLNG(Cga% - 8 * (h% > 0))
				IF p&(ind%) = 4 AND g% > 80 THEN
					p&(ind%) = 6   ' Spezialfall Orange
				END IF
			CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
				p&(ind%) = CLNG((r% AND 64) \ 2 + (r% AND 128) \ 32 + (g% AND 64) \ 4 + (g% AND 128) \ 64 + (b% AND 64) \ 8 + (b% AND 128) \ 128)
			CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
				p&(ind%) = CLNG(r% AND 252) \ 4& + CLNG(g% AND 252) * 64& + CLNG(b% AND 252) * 16384&
			CASE ELSE
				ERROR 5
			END SELECT
			palOf& = palOf& + 4&
			ind% = ind% + 1
		NEXT i%
	END IF
	CLOSE 1
END SUB

SUB LiesPalette (p&(), ind%, anz%)
	DIM dosIntEin AS RegType, dosIntAus AS RegType
	IF anz% <= 16 THEN    ' Modus mit 4 bpp oder weniger => indirekt ber Index
		dosIntEin.ax = &H101A   ' VGA-BIOS-Funktion fr Farbmodus ermitteln
		CALL interrupt(&H10, dosIntEin, dosIntAus)
		IF dosIntAus.bx AND 1 THEN
			' Modus 16 DAC-Registergruppen  16 Farben
			andMsk% = &HF
			orMsk% = (dosIntAus.bx AND &HF00) \ 16  ' gewhlte DAC-Gruppe
		ELSE
			' Modus 4 DAC-Registergruppen  64 Farben
			andMsk% = &H3F
			orMsk% = (dosIntAus.bx AND &H300) \ 4   ' gewhlte DAC-Gruppe
		END IF
	END IF
	' PEL-Maske auslesen
	dosIntEin.ax = &H1019
	CALL interrupt(&H10, dosIntEin, dosIntAus)
	PELmsk% = dosIntAus.bx AND &HFF
	' DAC-Farben auslesen
	FOR i% = 0 TO anz% - 1
		IF anz% > 16 THEN
			DACind% = i%   ' beim 256-Farben-VGA-Modus kein Palettenindex
		ELSE
			' Palettenindex ermitteln
			dosIntEin.ax = &H1007
			dosIntEin.bx = i% OR &HFF00   ' Test mit FFh durchfhren
			CALL interrupt(&H10, dosIntEin, dosIntAus)
			fi% = ASC(RIGHT$(MKI$(dosIntAus.bx), 1))
			IF fi% = &HFF THEN
				PRINT "Keine VGA-Karte => Palette auslesen nicht mglich!"
				ERROR 5
			END IF
			DACind% = fi% AND andMsk% OR orMsk%
		END IF
		' RGB-Werte aus DAC-Register lesen
		dosIntEin.ax = &H1015
		dosIntEin.bx = DACind% AND PELmsk%
		CALL interrupt(&H10, dosIntEin, dosIntAus)
		r% = (dosIntAus.dx AND &H3F00) \ &H100
		g% = (dosIntAus.cx AND &H3F00) \ &H100
		b% = dosIntAus.cx AND &H3F
		p&(ind%) = CLNG(r%) + 256& * CLNG(g%) + 65536 * CLNG(b%)
		ind% = ind% + 1
	NEXT i%
END SUB

SUB PaletteUsingVGA (p&(), ind%, anz%)
	DIM dosIntEin AS RegType, dosIntAus AS RegType
	IF anz% <= 16 THEN
		' 4 bpp-Grafikmodus => Palettenindex setzen ntig
		' DAC-Gruppe 0 auswhlen (geht im folgenden sowohl fr 16x16 als auch
		' 4x64-Farbwahlmodus => Farbwahlmodus bleibt unverndert)
		dosIntEin.ax = &H1013
		dosIntEin.bx = &H1   ' BL=01h (Color-Select setzen), BH=0 (DAC-Gruppe 0)
		CALL interrupt(&H10, dosIntEin, dosIntAus)
		' Palettenindex setzen
		FOR i% = 0 TO anz% - 1
			dosIntEin.ax = &H1000
			dosIntEin.bx = i% * &H101  ' BH (Farbwert) = BL (Palettenregister) = i%
			CALL interrupt(&H10, dosIntEin, dosIntAus)
		NEXT i%
	END IF
	' DAC-Register laden
	FOR i% = 0 TO anz% - 1
		r% = CINT(p&(indp%) AND &H3F&)
		g% = CINT(p&(indp%) \ &H100& AND &H3F&)
		b% = CINT(p&(indp%) \ &H10000 AND &H3F&)
		dosIntEin.ax = &H1010
		dosIntEin.bx = i%
		dosIntEin.cx = b% + &H100 * g%  ' CH=Grn, CL=Blau
		dosIntEin.dx = r% * &H100       ' DH=Rot
		CALL interrupt(&H10, dosIntEin, dosIntAus)
		ind% = ind% + 1
	NEXT i%
END SUB

SUB SetzeBlinkattribut (ein%)
	DIM dosIntEin AS RegType, dosIntAus AS RegType
	dosIntEin.ax = &H1003
	dosIntEin.bx = -(ein% <> 0)
	CALL interrupt(&H10, dosIntEin, dosIntAus)
END SUB

SUB SpeichereBild (dn$, f#(), indf%, p&(), indp%, bpp%, mo%)
	CONST dpm& = 60& * 5000& \ 127&  ' Dichte: 60 dpi = 2362 Pixel/Meter
	aFa% = 1
	FOR i% = 1 TO bpp%
		aFa% = aFa% * 2
	NEXT i%
	BitmAbst& = CLNG(14 + 40 + 4 * aFa%)
	pu1$ = MKD$(f#(indf%))
	IF bpp% = 8 THEN
		xb& = CLNG(CVI(LEFT$(pu1$, 2)) \ 8)
	ELSE
		xb& = CLNG(CVI(LEFT$(pu1$, 2)))
	END IF
	yb& = CLNG(CVI(MID$(pu1$, 3, 2)))
	' Zeilenlnge in der Datei
	ZeiLaenge& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
	BildGroe& = yb& * ZeiLaenge&
	GesGroe& = BildGroe& + BitmAbst&

	OPEN dn$ + ".BMP" FOR OUTPUT AS 1
	' BITMAPFILEHEADER schreiben
	PRINT #1, "BM"; MKL$(GesGroe&); MKI$(0); MKI$(0); MKL$(BitmAbst&);
	' BITMAPINFOHEADER schreiben
	PRINT #1, MKL$(40&); MKL$(xb&); MKL$(yb&); MKI$(1); MKI$(bpp%); MKL$(0&);
	PRINT #1, MKL$(BildGroe&); MKL$(dpm&); MKL$(dpm&); MKL$(0&); MKL$(0&);

	' Farbpalette schreiben: Dabei werden die hintersten Bits entsprechend
	' gefllt, also z.B. bei EGA aus 10 => 10101010 => damit bleibt Weiss
	' auch wirklich weiss, und wird nicht wie bei alten DeluxePaint-Versionen
	' zu 240er- bzw. 192er-Grau umgewandelt

	FOR i% = 1 TO aFa%
		IF mo% = PalVlf% THEN
			PRINT #1, MKL$(p&(indp%));
		ELSE
			' BASIC-Palettenfarben der PALETTE-Anweisung in RGB-Werte umwandeln
			SELECT CASE mo%
			CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
				w% = CINT(p&(indp%))
				r% = 85 * ((w% AND 4) \ 2 + (w% AND 8) \ 8)
				g% = 85 * ((w% AND 2) + (w% AND 8) \ 8)
				b% = 85 * ((w% AND 1) * 2 + (w% AND 8) \ 8)
				IF p&(indp%) = 6& THEN   ' Spezialfall Orange
					g% = 85
				END IF
			CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
				w% = CINT(p&(indp%))
				r% = 85 * ((w% AND 32) \ 32 + (w% AND 4) \ 2)
				g% = 85 * ((w% AND 16) \ 16 + (w% AND 2))
				b% = 85 * ((w% AND 8) \ 8 + (w% AND 1) * 2)
			CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
				r% = CINT(p&(indp%) * 4& AND 252&) + CINT(p&(indp%) \ 16& AND 3&)
				g% = CINT(p&(indp%) \ 64& AND 252&) + CINT(p&(indp%) \ 4096& AND 3&)
				b% = CINT(p&(indp%) \ 16384& AND 252&) + CINT(p&(indp%) \ 1048576 AND 3&)
			CASE ELSE
				PRINT "Ungltiger Palettenmodus"
				ERROR 5
			END SELECT
			PRINT #1, CHR$(b%); CHR$(g%); CHR$(r%); CHR$(0);
		END IF
		indp% = indp% + 1
	NEXT i%

	' Bitmapdaten selber speichern
	SELECT CASE bpp%
	CASE 4
		' 4bpp-Modus
		DIM h%(3)
		zl2% = CINT(ZeiLaenge& \ 4&)
		pu1$ = SPACE$(4 * zl2%)
		pu2$ = SPACE$(4)
		FOR y& = CLNG(2 * indf% + 1) + (yb& - 1&) * CLNG(zl2%) TO CLNG(2 * indf% + 1) STEP CLNG(-zl2%)
			FOR x% = 0 TO zl2% - 1
				MID$(pu1$, 4 * x% + 1) = MID$(MKD$(f#(CINT((y& + CLNG(x%)) \ 2&))), 1 + 4 * CINT(y& + CLNG(x%) AND 1&), 4)
			NEXT x%
			FOR i% = 1 TO zl2%
				FOR j% = 0 TO 3
					h%(j%) = ASC(MID$(pu1$, i% + zl2% * j%))
				NEXT j%
				FOR j% = 4 TO 1 STEP -1
					w% = 0
					FOR k% = 3 TO 0 STEP -1
						w% = 2 * w% + (h%(k%) AND 1) + (h%(k%) AND 2) * 8
						h%(k%) = h%(k%) \ 4
					NEXT k%
					MID$(pu2$, j%) = CHR$(w%)
				NEXT j%
				PRINT #1, pu2$;
			NEXT i%
		NEXT y&
		indf% = indf% + CINT(yb& * CLNG(zl2%) \ 2&) + 1
	CASE 1, 8
		' Zeilenlnge in Bytes im GET/PUT-Feld
		zl2& = (xb& * CLNG(bpp%) + 7&) \ 8&
		rest% = CINT(ZeiLaenge& - zl2&)
		FOR y& = 8& * CLNG(indf%) + (yb& - 1&) * zl2& + 4& TO 8& * CLNG(indf%) + 4& STEP -zl2&
			FOR x& = y& TO y& + zl2& - 1&
				z$ = MID$(MKD$(f#(CINT(x& \ 8&))), 1 + CINT(x& AND 7&), 1)
				PRINT #1, z$;
			NEXT x&
			' Lcke fllen, damit 32-bit-aligned
			PRINT #1, STRING$(rest%, z$);
		NEXT y&
		indf% = indf% + CINT((yb& * zl2& + 11&) \ 8&)
	CASE ELSE
		PRINT "Ungltige Farbtiefe"
		ERROR 5
	END SELECT
	' Kontrolle
	IF LOF(1) <> GesGroe& THEN
		PRINT "Fehler beim Speichern"
		ERROR 57
	END IF
	CLOSE 1
END SUB

SUB SpeichereBildschirmAlsBMP (dn$, zh%)
	' Abfragen ber BIOS
	DIM dosIntEin AS RegType, dosIntAus AS RegType
	dosIntEin.ax = &HFFE   ' Funktion 0Fh (Videomodus auslesen)
	CALL interrupt(&H10, dosIntEin, dosIntAus)
	vMod% = dosIntAus.ax AND &HFF
	xGr% = ASC(RIGHT$(MKI$(dosIntAus.ax), 1))
	dosIntEin.ax = &H1130
	dosIntEin.bx = &H0
	CALL interrupt(&H10, dosIntEin, dosIntAus)
	yGr% = (dosIntAus.dx AND &HFF) + 1
	xAufl% = 8 * xGr%            ' Zeichen bei CGA/EGA/VGA immer 8 Pixel breit
	yAufl% = dosIntAus.cx * yGr% ' Hier entsprechende Zeichenmatrix
	SELECT CASE vMod%
	CASE 0, 2, 7     ' Textmodus monochrom
		bpp% = 1
		tm% = -1
	CASE 1, 3        ' Textmodus farbig
		bpp% = 4
		tm% = -1
	CASE 6, 17
		bpp% = 1
		tm% = 0
	CASE 4, 5, 15
		bpp% = 2   ' Bemerkung: Nicht untersttzt!
		tm% = 0
	CASE 13, 14, 16, 18
		bpp% = 4
		tm% = 0
	CASE 19
		bpp% = 8
		tm% = 0
	CASE ELSE
		PRINT "Nicht untersttzter Videomodus"
		ERROR 5
	END SELECT
	IF tm% THEN
		yAufl% = zh% * yGr%   ' verwende angegebene Auflsung
	END IF
	DIM f#((xGr% \ 8) * yAufl% * bpp%)
	IF tm% THEN
		ErzeugeTextGrafik f#(), 0, 0, 0, xGr%, yGr%, bpp%, zh%
	ELSE
		GET (0, 0)-(xAufl% - 1, yAufl% - 1), f#
	END IF
	aFa% = 1
	FOR i% = 1 TO bpp%
		aFa% = aFa% * 2
	NEXT i%
	DIM Pal&(aFa% - 1)
	LiesPalette Pal&(), 0, aFa%
	SpeichereBild dn$, f#(), 0, Pal&(), 0, bpp%, PalVGA%
	ERASE f#, Pal&   ' Speicher wieder freigeben
END SUB

