' Modulsammlung fr Grafik-Import und Export von QuickBASIC-
' GET/PUT-Grafikfeldern ins Windows Bitmap (*.BMP)-Format und
' umgekehrt sowie Laden der Farbpalette

' (c) 1999 by Andreas Meile, CH-8242 Hofen SH

' Version 1.1 fr Compiler:
' - verwendet doppeltgenaue Felder, um mit /AH (Large Memory Model)
'   Felder > 64 KB zu ermglichen
' - Durch Verwendung von VGA-BIOS-Systemaufrufen ist es auch mglich, die
'   Farbpalette direkt aus der Grafikkarte auszulesen sowie VGA-Farben in
'   jeder Auflsung einzusetzen

' Definitionen

DECLARE SUB HoleBildInfo (dn$, xb&, yb&, bpp%, gr%)
' Ermittelt Bildattribute:
' xb&, yb&  : Grsse
' bpp%      : Farbtiefe
' gr%       : Grsse des Bildes

DECLARE SUB LadeBild (dn$, f#(), ind%)
' Ldt Bild dn$ ins Feld f#() ab Startindex ind%
' ind% ist fr Animationen vorgesehen, um mehrere Bilder
' ins gleiche Feld laden knnen

DECLARE SUB LadePalette (dn$, p&(), ind%, mo%)
' Ldt Farbpalette Bild dn$ ins Feld p&() ab Startindex ind%
' ind% ist fr mehrere Paletten pro Feld vorgesehen
' mo% = Farbpalettenmodus

DECLARE SUB SpeichereBild (dn$, f#(), indf%, p&(), indp%, bpp%, mo%)
' Ausschnitt als Datei speichern. Bedeutung:
' dn$   = Dateiname ohne Endung ".BMP"
' f#()  = mit GET() ausgeschnittene Grafik, indf% = Startindex
' p&()  = fr PALETTE USING bestimmte Farbpalette, indp% = Startindex
' bpp%  = Bildtiefe in Bits pro Pixel
' mo%   = Farbpalettenmodus

' Werte fr Farbpalettenmodus mo%
CONST PalCGA% = 0   ' fr SCREEN 1/2/7/8
CONST PalEGA% = 1   ' fr SCREEN 0/9
CONST PalVGA% = 2   ' fr SCREEN 11/12/13
CONST PalVlf% = 3   ' verlustfreier Spezialmodus

' Neu in V1.1
' Vorbedingung: VGA-Karte muss vorhanden sein, d.h. bei CGA/EGA folgendes
'               nicht anwendbar!

DECLARE SUB LiesPalette (p&(), ind%, anz%)
' Farbpalette im VGA-Format (unabhngig vom SCREEN-Videomodus!) einlesen
' p&()  = fr PALETTE USING bestimmte Farbpalette, indp% = Startindex
' anz%  = Anzahl der einzulesenden Farben; falls 16, dann wird auch der
'         Palettenindex mit DAC-Registergruppe und Farbmodus bercksichtigt

DECLARE SUB PaletteUsingVGA (p&(), ind%, anz%)
' Gegenstck zu LiesPalette: Im Unterschied zu PALETTE USING erlaubt diese
' Prozedur in allen SCREEN-Videomodi die Verwendung aller 262'144 VGA-Farben
' p&()  = fr PALETTE USING bestimmte Farbpalette, indp% = Startindex
' anz%  = Anzahl der zu setzenden Farben; falls 16, dann wird auch der
'         Palettenindex gesetzt. Anmerkungen dazu: Es wird immer die erste
'         DAC-Registergruppe verwendet und der Index ab 0 beginnend abgefllt

DECLARE SUB SetzeBlinkattribut (ein%)
' Erlaubt das Ein- (ein%=-1) und Ausschalten (ein%=0) vom Blinkattribut
' bei COLOR x% mit x%>=16, so dass man dafr alle 16 Hintergrundfarben zur
' Verfgung hat

DECLARE SUB ErzeugeTextGrafik (f#(), ind%, xAb%, yAb%, xGr%, yGr%, bpp%, zh%)
' Wandelt den Textbildschirmausschnitt xAb% (linker Abstand in Spalten), yAb%
' (oberer Abstand in Zeilen), xGr% (Breite in Spalten), yGr% (Hhe in Zeilen)
' in eine PUT()-Grafik nach f#() ab Startindex ind% um. Optionen:
' bpp% = 1 => Monochrombitmap fr SCREEN 2/11
' bpp% = 4 => Farbbitmap fr SCREEN 7/8/9/12
' Hinweis: Bei Monochrom werden keine Attribute bercksichtigt
' zh% = Gewnschte Zeichensatzhhe in Pixel. Zulssige Werte: 8, 14 und 16

DECLARE SUB SpeichereBildschirmAlsBMP (dn$, zh%)
' reine Frontend-Prozedur: Speichert im Sinne von <PrintScreen> den aktuellen
' Bildschirminhalt als Grafik ab. Im Falle von Textmodus kann noch die
' Zeichenhhe in zh% gewhlt werden.

